Attribute VB_Name = "BIT"
Public Function BIT_Transformation()
        
    form1.StatusBar1.Panels.Item(1).Text = "Calculating"
    
    Dim temp_ia As Double
    Dim time_ia As Double
    Dim time_incub As Double
    Dim A1_Temp As Double
    
    Dim x_ini_bit As Double 'equilibrium x_ba at IA
    Dim time_bit As Double
    Dim temp_bit As Double  'BIT temperature
    Dim x_ab_bit As Double
    Dim x_ba_bit As Double
    Dim X_BAR_BIT As Double  'mean field approximation
    Dim diffus_bit As Double
    
    Dim composition_steel(1 To 11) As Double 'steel original composition
    Dim composition(1 To 11) As Double
    Dim X_Components(1 To 11) As Double
    Dim composition_omega(12) As Double  'composition for calculate omega
    
    Dim Volume_f_austenite() As Double
    Dim Volume_f_bainite() As Double
    
    
    Dim volume_f_ferrite As Double
    Dim Volume_f_Austenite_IA As Double
    
    Dim Mass_f_Austenite_IA As Double  'mass fraction of austenite after IA
    Dim Mass_f_Austenite As Double  'final mass fraction of austenite
    Dim Mass_f_Ferrite As Double
    Dim Mass_f_Bainite As Double
    
    Dim carbon_x_austenite() As Double
    Dim carbon_w_austenite() As Double
  
    Dim lambda As Double   'interlath spacing
    Dim time_step_BIT As Integer
    Dim delta_time_bit As Double
    
    Dim z() As Double
    Dim L() As Double
    
    Dim Area_a() As Double  'area above x_bar in carbon concentration profile
    Dim Area_b() As Double  'area below x_bar in carbon concentration profile
    
    Dim delta_G() As Double   'austenite to cementite driving force
    Dim NucleateVolume() As Double 'nucleate volume
    Dim Iron_composition() As Double 'iron
    Dim Dilute_x() As Double    'carbon dilution due to cementite precipitation, in each step
    Dim Dilute_total As Double  'carbon dilution total
    Dilute_total = 0
    Dim TransVol() As Double    'transformed volume fraction of cementite
    Dim NucleationRate() As Double  'cementite nucleation rate
    Dim C0() As Double
    
    Dim vfAust As Double    'volume fraction of untransformed austenite
    Dim CMT_V_f As Double  'Equilibrium volume fraction of Cementite
   
   
    time_step_BIT = 1000
    time_bit = Val(form1.BIT_Time(3).Text)
    delta_time_bit = time_bit / time_step_BIT
    
    ReDim z(0 To time_step_BIT)
    ReDim carbon_x_austenite(0 To time_step_BIT)
    ReDim carbon_w_austenite(0 To time_step_BIT)
    ReDim L(0 To time_step_BIT)
    ReDim Area_a(0 To time_step_BIT)
    ReDim Area_b(0 To time_step_BIT)
    ReDim NucleateVolume(0 To time_step_BIT)
    ReDim delta_G(0 To time_step_BIT)
    ReDim Iron_composition(0 To time_step_BIT)
    ReDim Dilute_x(0 To time_step_BIT)
    ReDim TransVol(0 To time_step_BIT)
    ReDim NucleationRate(0 To time_step_BIT)
    ReDim Volume_f_austenite(0 To time_step_BIT)
    ReDim Volume_f_bainite(0 To time_step_BIT)
    ReDim C0(0 To time_step_BIT)
    
    NucleateVolume(0) = 0
'=================================================================================
' read input
    composition(1) = Val(form1.Carbon(0))
    composition(2) = Val(form1.Manganese(1))
    composition(3) = Val(form1.Silicon(2))
    composition(4) = Val(form1.Aluminum(3))
    composition(5) = Val(form1.Phosphorus(4))
    composition(6) = Val(form1.Niobium(5))
    composition(7) = Val(form1.Molybdenum(6))
    composition(8) = Val(form1.Nitrogen(7))
    composition(9) = Val(form1.Sulfur(8))
    composition(10) = Val(form1.Boron(9))
    composition(11) = 100 - (Val(form1.Carbon(0)) + Val(form1.Manganese(1)) + Val(form1.Silicon(2)) _
    + Val(form1.Aluminum(3)) + Val(form1.Phosphorus(4)) + Val(form1.Niobium(5)) + Val(form1.Molybdenum(6)) _
    + Val(form1.Nitrogen(7)) + Val(form1.Sulfur(8)) + Val(form1.Boron(9)))
    
    For i = 1 To 11
        composition_steel(i) = composition(i)   'save a copy of the original composition
    Next i
    
    temp_ia = Val(form1.IA_Temp(0).Text) + 273
    time_ia = Val(form1.IA_Time(1).Text)
    temp_bit = Val(form1.BIT_Temp(2).Text) + 273
    lambda = Val(form1.interlath_spacing.Text)  'micron
    
    A1_Temp = FIND_A1(composition())
    
    If (temp_ia < A1_Temp) Then
        If MsgBox("Inputted IA temperature is below Ae1", vbCritical) = vbOK Then
            GoTo END_BIT
        End If
    End If
 
   
    ' IA as equilibrium  'composition will change
    Call X_Carbon_IA(temp_ia, x_ab_bit, x_ini_bit, composition(), X_Components(), Mass_f_Austenite_IA)
    
    Volume_f_Austenite_IA = Mass_f_Austenite_IA / (Mass_f_Austenite_IA / 1 + (100 - Mass_f_Austenite_IA) / 0.918559)
     
    Dim composition_IA(1 To 11) As Double       'austenite composition after IA
    For i = 1 To 11
        composition_IA(i) = composition(i)
    Next i
    '--------------------------------------------------------------------------------
'   compositon used to calculate carbon-carbon interaction energy Omega
'   steel composition(wt%):C  Si   Mn    Ni   Mo   Cr  V   Co  Cu  Al   W
    
    composition_omega(0) = composition(1)
    composition_omega(1) = composition(3)
    composition_omega(2) = composition(2)
    composition_omega(3) = 0
    composition_omega(4) = composition(7)
    composition_omega(5) = 0
    composition_omega(6) = 0
    composition_omega(7) = 0
    composition_omega(8) = 0
    composition_omega(9) = composition(4)
    composition_omega(10) = 0

    WDIFF = MAP_STEEL_OMEGA(composition_omega(), x)
    diffus_bit = MAP_STEEL_DIFFUS(x, temp_bit, WDIFF)
    diffus_bit = diffus_bit * 10 ^ 8 * 0.5 'convert units from cm2/s to micron2/s
    
    
    Call CEMENTITE(composition(), temp_bit, CMT_V_f)
 
    'BIT  stage
    Call X_Carbon_BIT(temp_bit, x_ab_bit, x_ba_bit, composition(), X_Components())
    Dim C_W_T0 As Double
    Dim C_X_T0 As Double
    Call Find_T0(composition(), temp_bit, C_W_T0, C_X_T0)
    
    x_ba_bit = x_ba_bit
    
    Volume_f_bainite(0) = 0
    Volume_f_austenite(0) = Volume_f_Austenite_IA
    
    X_BAR_BIT = x_ini_bit
    
    'initial calc
    z(0) = (x_ba_bit - X_BAR_BIT) / Sqr((X_BAR_BIT - x_ab_bit) * (x_ba_bit - x_ab_bit)) * Sqr(diffus_bit * delta_time_bit * 0)
    '       X_BAR_BIT = (X_ini_BIT * LAMBDA / 2 - X_ab_BIT * Z(i)) / (LAMBDA / 2 - Z(i))   'mean field approximation
    L(0) = 2 * z(0) * (X_BAR_BIT - x_ab_bit) / (x_ba_bit - X_BAR_BIT)
    
    carbon_x_austenite(0) = x_ini_bit
    carbon_w_austenite(0) = composition(1)
    
    For i = 1 To time_step_BIT - 1
        
       
        If L(i - 1) >= (lambda / 2 - z(i - 1)) Then
            'diffusion field lenger than width of austenite
            C0(i) = (X_BAR_BIT * lambda - 2 * x_ab_bit * z(i - 1) - x_ba_bit * (lambda / 2 - z(i - 1)) - 0.5 * Dilute_x(i - 1)) / (lambda / 2 - z(i - 1))
          '  If C0(i) < x_ini_bit Then
          '      C0(i) = x_ini_bit
          '  End If
            'C0(i) = (X_BAR_BIT * lambda - 2 * x_ab_bit * z(i - 1) - x_ba_bit * (lambda / 2 - z(i - 1))) / (lambda / 2 - z(i - 1))
            z(i) = z(i - 1) + 0.5 * (x_ba_bit - C0(i)) / ((x_ba_bit - x_ab_bit) * (lambda / 2 - z(i - 1))) * diffus_bit * delta_time_bit
            L(i) = lambda / 2 - z(i)
            
                
         Else
           'z(i) = (x_ba_bit - X_BAR_BIT) / Sqr((X_BAR_BIT - x_ab_bit) * (x_ba_bit - x_ab_bit)) * Sqr(diffus_bit * delta_time_bit * i)
            z(i) = Dilute_x(i) + Sqr(Dilute_x(i) ^ 2 + (X_BAR_BIT - x_ab_bit) * (x_ba_bit - X_BAR_BIT) ^ 2 * diffus_bit * delta_time_bit * i / (x_ba_bit - x_ab_bit)) / (X_BAR_BIT - x_ab_bit)
          '  z(i) = z(i - 1) + delta_time_bit * diffus_bit / (x_ba_bit - x_ab_bit) * (x_ba_bit - X_BAR_BIT) ^ 2 / _
            (2 * (z(i - 1) * (X_BAR_BIT - x_ab_bit) - Dilute_x(i - 1)))
            L(i) = 2 * (z(i) * (X_BAR_BIT - x_ab_bit) - Dilute_x(i)) / (x_ba_bit - X_BAR_BIT)
         End If

        If z(i) >= lambda / 2 Or z(i) < z(i - 1) Then
          Exit For
        End If
        Area_a(i) = 0.5 * L(i) * (x_ba_bit - X_BAR_BIT)
        Area_b(i) = (X_BAR_BIT - x_ab_bit) * z(i)
        
        Volume_f_bainite(i) = Volume_f_Austenite_IA * z(i) / (lambda / 2)
        Volume_f_austenite(i) = Volume_f_Austenite_IA * (1 - z(i) / (lambda / 2))
'========================================================
'cementite growth, carbon dilute process
    
        vfAust = 1 - z(i) / (lambda / 2)
        
        delta_G(i) = Driving_Force.DrivingForce(temp_bit, composition())
        Call Cementite_PPT(temp_bit, delta_G(i), X_Components(), vfAust, NucleationRate(i))
     
        NucleateVolume(i) = NucleateVolume(i - 1) + (delta_time_bit * NucleationRate(i)) / (delta_time_bit * i)
        '----------------- Zener' model for diffusion controlled growth.
        Dim GrowthRate As Double
        Dim CONST_A As Double
        CONST_A = 0.00000001
        
        GrowthRate = 0.5 * CONST_A * (diffus_bit / temp_bit) ^ 0.5
        
        '------------------ Johnson-Mehl equation for spherical grains
           ' transformed cementite volume fraction over equilibrium volume
        
        TransVol(i) = 1 - Exp(-3.1415 * NucleateVolume(i) * GrowthRate ^ 2 * (delta_time_bit * i) ^ 2 / 3)
        cementitevol = TransVol '* CMT_V_f
        If TransVol(i) >= 1 Then
           ' Exit For
        End If
        
       
        
        Call X_Carbon_BC(temp_bit, X_bc, X_cb, composition(), X_Components())
        
        'Composition(1) = X_bc + (Composition(1) - X_bc) * (1 - TransVol(i))
        Dilute_x(i) = (x_ini_bit - x_ab_bit) * (lambda / 2) * (TransVol(i))
 '==========================================================================================
    
        
        carbon_x_austenite(i) = ((x_ini_bit * lambda / 2 - x_ab_bit * z(i)) - Dilute_x(i)) / (lambda / 2 - z(i))
        
        carbon_w_austenite(i) = 12 * carbon_x_austenite(i) / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        
        carbon_w_austenite(i) = carbon_w_austenite(i) * 100 'convert to weight percent
        composition(1) = carbon_w_austenite(i)
       
        composition(2) = 100 * X_Components(2) * 55 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(3) = 100 * X_Components(3) * 28 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(4) = 100 * X_Components(4) * 27 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(5) = 100 * X_Components(5) * 31 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(6) = 100 * X_Components(6) * 93 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(7) = 100 * X_Components(7) * 96 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(8) = 100 * X_Components(8) * 14 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(9) = 100 * X_Components(9) * 32 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(10) = 100 * X_Components(10) * 11 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        composition(11) = 100 * X_Components(11) * 56 / (carbon_x_austenite(i) * 12 + (X_Components(2) * 55 + _
        X_Components(3) * 28 + X_Components(4) * 27 + X_Components(5) * 31 + X_Components(6) * 93 + X_Components(7) * 96 + _
        X_Components(8) * 14 + X_Components(9) * 32 + X_Components(10) * 11 + X_Components(11) * 56))
        
        
        Iron_composition(i) = composition(11)

        
        If z(i) > lambda / 2 Or carbon_x_austenite(i) < 0 Or carbon_x_austenite(i) > x_ba_bit Then
  '          Exit For
        End If
        
        
        If NucleateVolume(i) > 0.02 Then
       '     Exit For
        End If

    Next i
    
    
    
Write_Result:    Dim i_last As Integer
    i_last = i
    
    
    'mass fraction of each phase
    Mass_f_Ferrite = 100 - Mass_f_Austenite_IA
    Mass_f_Bainite = Mass_f_Austenite_IA * z(i - 1) / (lambda / 2)
    Mass_f_Austenite = Mass_f_Austenite_IA * (lambda / 2 - z(i - 1)) / (lambda / 2)
    
    Dim Total_Volume As Double
    
    Total_Volume = (Mass_f_Ferrite + Mass_f_Bainite) / 0.918559 + Mass_f_Austenite / 1
  
    volume_f_ferrite = (Mass_f_Ferrite / 0.918559) / Total_Volume

    Call WriteResult(temp_ia, time_ia, temp_bit, time_bit, time_incub, lambda, volume_f_ferrite, _
    diffus_bit, X_bc, X_cb, x_ab_bit, x_ba_bit, x_ini_bit, delta_time_bit, _
    composition_steel(), composition_IA(), composition(), carbon_w_austenite(), carbon_x_austenite(), _
    z(), L(), Area_a(), Area_b(), i_last, NucleateVolume(), delta_G(), Iron_composition(), Dilute_x(), _
    TransVol(), NucleationRate(), Volume_f_austenite(), Volume_f_bainite(), C0())
    
END_BIT: End Function

Public Function Cementite_PPT(ByVal T As Double, ByVal delta_G As Double, _
ByRef X_Components() As Double, ByVal vfAust As Double, ByRef NucleationRate As Double)   'cementite precipitation model
                                    'volume fraction of untransformed austenite
    
    Dim PI As Double
    PI = 3.1415926
    Dim composition_austenite(1 To 11) As Double
    Dim ShapeFactor As Double   'shape factor
    Dim SurfaceEnergy As Double
    Dim G_star As Double
    Dim Va As Double  'volume of an atom in the nucleus
    'Dim nucleationrate As Double
    Dim A_const As Double
    Dim No As Double    'density of nucleation site
    Dim k As Double     'Boltzman constant
    'Dim T As Double
    Dim Qc As Double    'Activation energy of carbon diffusion in austenite
    Dim N_star As Double    'critical size
    Dim R As Double 'factor of Si effect on nucleation rate
    
    Dim Delta_Gb As Double
    Dim Delta_Gb_Si As Double
    Dim Delta_Gb_Al As Double
    Dim Delta_Gb_P As Double
    
   'Delta_Gb_Si = 6 * 10 ^ (-19)  '400 C
    Delta_Gb_Si = 20 * 10 ^ (-19)    '450 C
    Delta_Gb_Al = 3 * 10 ^ (-19)
    Delta_Gb_P = 3 * 10 ^ (-19)
    
    Delta_Gb = X_Components(3) * Delta_Gb_Si + X_Components(4) * Delta_Gb_Al + X_Components(5) * Delta_Gb_P
    
    
    A_const = 10 ^ 73  'assumed
    No = 6.02 * 10 ^ 23    '1 mole
    k = 1.3806503 * 10 ^ (-23)   'm^2 kg s^-2 K^-1
    Va = 12.93  'angstrom^3
    Va = Va * 10 ^ (-30)
    ShapeFactor = (6 * PI ^ 0.5 * Va) ^ (2 / 3)
    
    
    SurfaceEnergy = 1000 'erg/cm^2
    SurfaceEnergy = SurfaceEnergy * 10 ^ (-7) * 10 ^ 4  'J/m^2
    
    N_star = -2 * ShapeFactor * SurfaceEnergy / (3 * delta_G)
    
    Qc = 138 * 10 ^ 3  'Jole/mole
    
    G_star = (4 * ShapeFactor ^ 3 * SurfaceEnergy ^ 3) / (27 * (delta_G) ^ 2)
    
    ' Number of nucleus formed during an unit time in a unit volume.
    NucleationRate = vfAust * A_const * No * Exp(-Qc / (No * k * T)) * Exp(-G_star / (k * T))
    
    R = Exp(G_star / (k * T) * ((1 / (1 - Delta_Gb / delta_G)) ^ 2 - 1))
    NucleationRate = NucleationRate * R
    
End Function



