Attribute VB_Name = "CT0"
Public Function Find_T0(ByRef composition() As Double, ByVal Temp As Double, ByRef C_W_T0 As Double, _
                            ByRef C_X_T0 As Double)
' demonstration of the MTDATA Application Interface
'string for component/phase/species name
Dim name As String * 50
Dim pvar As String * 10
Dim count As Long

Dim G_Austenite As Double 'Gibbs energy of austenite
Dim G_Ferrite As Double 'Gibbs energy of ferrite
Dim delta_C As Double
delta_C = 0.005
Dim Carbon As Double 'to save a copy of original carbon concentration

Carbon = composition(1)

'set system composition
For count = 1 To INIT_NO_OF_COMPONENTS()
    Call SET_INIT_COMPONENT_MASS(count, composition(count))
Next


Dim CCPT As Long

CCPT = INIT_COMPONENT_NO("C", Len("C"))


'set appropriate pressure /Pa and temperature in Kelvin
Call SET_PRESSURE(101325#)
Call SET_TEMPERATURE(Temp)


'Ferrite----------------------------------
'classify phases
For count = 1 To INIT_NO_OF_PHASES()
    Call INIT_PHASE_NAME(name, 50, count)
    If (Trim(name) = "BCC_A2") Then
        Call SET_INIT_PHASE_CLASS(count, NORMAL)
    Else
        Call SET_INIT_PHASE_CLASS(count, ABSENT)
    End If
Next

'do the calculation
Call COMPUTE_EQUILIBRIUM
NPHASE2 = ACT_PHASE_NO("BCC_A2", Len("BCC_A2"))
G_Ferrite = GIBBS_ENERGY_OF_PHASE(NPHASE2)

'Austenite----------------------------------
'classify phases
For count = 1 To INIT_NO_OF_PHASES()
    Call INIT_PHASE_NAME(name, 50, count)
    If (Trim(name) = "FCC_A1") Then
        Call SET_INIT_PHASE_CLASS(count, NORMAL)
    Else
        Call SET_INIT_PHASE_CLASS(count, ABSENT)
    End If
Next

'do the calculation
Call COMPUTE_EQUILIBRIUM
NPHASE1 = ACT_PHASE_NO("FCC_A1", Len("FCC_A1"))
G_Austenite = GIBBS_ENERGY_OF_PHASE(NPHASE1)

Do
        If G_Austenite > G_Ferrite Then
            composition(1) = composition(1) + delta_C
        ElseIf G_Austenite < G_Ferrite Then
            composition(1) = composition(1) - delta_C
        End If
        
        
        For count = 1 To INIT_NO_OF_COMPONENTS()
            Call SET_INIT_COMPONENT_MASS(count, composition(count))
        Next

        'Ferrite----------------------------------
        'classify phases
        For count = 1 To INIT_NO_OF_PHASES()
            Call INIT_PHASE_NAME(name, 50, count)
            If (Trim(name) = "BCC_A2") Then
                Call SET_INIT_PHASE_CLASS(count, NORMAL)
            Else
                Call SET_INIT_PHASE_CLASS(count, ABSENT)
            End If
        Next

        Call COMPUTE_EQUILIBRIUM
        NPHASE2 = ACT_PHASE_NO("BCC_A2", Len("BCC_A2"))
        G_Ferrite = GIBBS_ENERGY_OF_PHASE(NPHASE2)
        
        'Austenite----------------------------------
        'classify phases
        For count = 1 To INIT_NO_OF_PHASES()
            Call INIT_PHASE_NAME(name, 50, count)
            If (Trim(name) = "FCC_A1") Then
                Call SET_INIT_PHASE_CLASS(count, NORMAL)
            Else
                Call SET_INIT_PHASE_CLASS(count, ABSENT)
            End If
        Next
        
        Call COMPUTE_EQUILIBRIUM
        
        NPHASE1 = ACT_PHASE_NO("FCC_A1", Len("FCC_A1"))
        G_Austenite = GIBBS_ENERGY_OF_PHASE(NPHASE1)
    
        If (G_Austenite - G_Ferrite < 10000) Then
            Exit Do
        End If
       
Loop
C_X_T0 = COMPONENT_X_OF_PHASE(CCPT, NPHASE1, ACTIVE)
C_W_T0 = COMPONENT_W_OF_PHASE(CCPT, NPHASE1, ACTIVE)

composition(1) = Carbon

If (NUMBER_OF_ERRORS() <> 0) Then
    'error found during calculation.
    'clear error flag, write out the error
    MsgBox ("Error in calculation")
    Call WRITE_ERROR
End If

End Function
