Attribute VB_Name = "FIND_A1_T"
Public Function FIND_A1(ByRef composition() As Double)

Dim name As String * 50
Dim pvar As String * 10
Dim count As Long
Dim Temp As Double
Dim delta_temp As Double
Temp = 720  ' initial value 680 Celsiurs
Temp = Temp + 273.15
delta_temp = 0.2

Dim X_ab As Double
Dim X_ba As Double



'set system composition
For count = 1 To INIT_NO_OF_COMPONENTS()
    Call SET_INIT_COMPONENT_MASS(count, composition(count))
Next


Dim CCPT As Long

CCPT = INIT_COMPONENT_NO("C", Len("C"))


'set appropriate pressure /Pa and temperature in Kelvin
Call SET_PRESSURE(101325#)
Call SET_TEMPERATURE(Temp)




'----------------------------------
'classify phases
For count = 1 To INIT_NO_OF_PHASES()
    Call INIT_PHASE_NAME(name, 50, count)
    If (Trim(name) = "BCC_A2") Then
        Call SET_INIT_PHASE_CLASS(count, NORMAL)
    ElseIf (Trim(name) = "FCC_A1") Then
        Call SET_INIT_PHASE_CLASS(count, NORMAL)
    ElseIf (Trim(name) = "CEMENTITE") Then
        Call SET_INIT_PHASE_CLASS(count, NORMAL)
    Else
        Call SET_INIT_PHASE_CLASS(count, ABSENT)
    End If
Next



'do the calculation
Call COMPUTE_EQUILIBRIUM


Dim count2 As Double
Dim NPHASE As Long   'number of phase present at equilibrium
Dim phase_name() As String * 10
Dim flag As Integer
Dim temp1 As Double     'lower
Dim temp2 As Double     'upper
Dim flag_cementite As Integer

NPHASE = EQUIL_NO_OF_PHASES()
ReDim phase_name(1 To NPHASE)

'------------------------------------
' find if cementite present at the initial temperature

flag_cementite = 0
For count = 1 To NPHASE
    Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
    If Trim(phase_name(count)) = "CEMENTITE" Then
        flag_cementite = 1
    End If
Next



If flag_cementite = 1 Then      'cementite present in equilbirium, then initial T is below Ae1

    flag = 1
    Temp = Temp + 2
    
    Call COMPUTE_EQUILIBRIUM

    NPHASE = EQUIL_NO_OF_PHASES()
    ReDim phase_name(1 To NPHASE)
    
' find the region where A1 is in this 5 degree range
    Do Until flag = 0
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
            If Trim(phase_name(count)) = "CEMENTITE" Then
                Temp = Temp + 2
                SET_TEMPERATURE (Temp)
                Call COMPUTE_EQUILIBRIUM
                NPHASE = EQUIL_NO_OF_PHASES()
            End If
        Next
    
        ReDim phase_name(1 To NPHASE)
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
        Next
    
        flag = 0
        For count = 1 To NPHASE
            If Trim(phase_name(count)) = "CEMENTITE" Then
                flag = 1
            End If
        Next
    Loop

' make it more precise
    flag = 1
    temp2 = Temp - 2 + delta_temp
    SET_TEMPERATURE (temp2)
    Call COMPUTE_EQUILIBRIUM

    NPHASE = EQUIL_NO_OF_PHASES()
    ReDim phase_name(1 To NPHASE)

    Do Until flag = 0
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
            If Trim(phase_name(count)) = "CEMENTITE" Then
                temp2 = temp2 + delta_temp
                SET_TEMPERATURE (temp2)
                Call COMPUTE_EQUILIBRIUM
                NPHASE = EQUIL_NO_OF_PHASES()
            End If
        Next
    
        ReDim phase_name(1 To NPHASE)
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
        Next
    
        flag = 0
        For count = 1 To NPHASE
            If Trim(phase_name(count)) = "CEMENTITE" Then
                flag = 1
            End If
        Next
   
    Loop
    
Else        'No cementite, then initial T is above Ae1
    flag = 1
    
    Temp = Temp - 2
    SET_TEMPERATURE (Temp)
    Call COMPUTE_EQUILIBRIUM

    NPHASE = EQUIL_NO_OF_PHASES()

    ReDim phase_name(1 To NPHASE)
    
    
' find the region where A1 is in this 5 degree range
    Do Until flag = 0
        
        flag = 1
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
            If Trim(phase_name(count)) = "CEMENTITE" Then
                flag = 0
            End If
        Next
        
        If flag = 1 Then
            Temp = Temp - 2
            SET_TEMPERATURE (Temp)
                Call COMPUTE_EQUILIBRIUM
                NPHASE = EQUIL_NO_OF_PHASES()
        End If
        
        flag = 1
        ReDim phase_name(1 To NPHASE)
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
            If Trim(phase_name(count)) = "CEMENTITE" Then
                flag = 0
            End If
        Next
    Loop
    
'---------------------------------------------
' make it more precise
    flag = 1
    temp2 = Temp - 2 + delta_temp
    SET_TEMPERATURE (temp2)
    Call COMPUTE_EQUILIBRIUM

    NPHASE = EQUIL_NO_OF_PHASES()
    ReDim phase_name(1 To NPHASE)

    Do Until flag = 0
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
            If Trim(phase_name(count)) = "CEMENTITE" Then
                temp2 = temp2 + delta_temp
                SET_TEMPERATURE (temp2)
                Call COMPUTE_EQUILIBRIUM
                NPHASE = EQUIL_NO_OF_PHASES()
            End If
        Next
    
        ReDim phase_name(1 To NPHASE)
        For count = 1 To NPHASE
            Call EQUIL_PHASE_NAME(phase_name(count), 10, count)
        Next
    
        flag = 0
        For count = 1 To NPHASE
            If Trim(phase_name(count)) = "CEMENTITE" Then
                flag = 1
            End If
        Next
   
    Loop
End If


If (NUMBER_OF_ERRORS() <> 0) Then
    'error found during calculation.
    'clear error flag, write out the error
    MsgBox ("Error in calculation")
    Call WRITE_ERROR
End If

FIND_A1 = temp2

End Function
