Attribute VB_Name = "Alpha3"
Public Const PI_SQRT = 1.77245385090552  ' //sqrt(PI)
Public Const R = 8.31441 '// R is the universal gas constant (in joules per mole per kelvin)
Public Const eps = 0.000001 ' //Newton Raphson stop condition
Public Const PI = 3.1415926
Public Const M = 80
Public Const time_STEPS = 100
Dim x As Double    ' // X is the carbon concentration in steel(in mole fraction)
Public Function transformation()


    Dim DIFFUS, WDIFF, W, T, Tc As Double
    Dim thick_ini, thick_end, thick_equi, f_pearlite, f_austenite, f_equi As Double
    Dim time(0 To time_STEPS - 1) As Double
    Dim thick(0 To time_STEPS - 1) As Double
    
    Dim alpha1(0 To time_STEPS - 1) As Double
    Dim Alpha3(0 To time_STEPS - 1) As Double
    Dim H1(0 To time_STEPS - 1) As Double  'supersaturation
    Dim X_Components(1 To 11) As Double
    
    
    Dim x_BAR(0 To time_STEPS - 1) As Double
    Dim D_BAR(0 To time_STEPS - 1) As Double
                'thick is the actual thickness of austenite
                ' thick_ini is the initial radius of pearlite particle
                'thick_end is the total thickness
                ' thick_equi is the equilibrium thickness
                'time is the annealing time
                'f_pearlite is initial pearlite volume fraction
                'f_austenite is austenite volume fraction
                'f_equi equilibrium austenite volume fraction
    Dim x_i, X_bc, X_cb, w_i, w_ab, w_ba, w_f As Double
                'x_iinitial carbon mole fraction in austenite
                'w_i is initial carbon weight percent in steel
                'w_f is initial carbon weight percent in ferrite
    Dim f1, f2, X1, X2, delta_y As Double 'delta_y is the difference between x1 and x2
    Dim k As Integer  'number of iteration
    k = 0
    
    Dim delta_time As Double
    delta_time = Val(form1.IA_Time(1)) / time_STEPS  ' in second
    
    Tc = Val(form1.BIT_Temp(2).Text)
    T = Tc + 273
    
    thick_ini = 20 ' in micron
'--------------------------------------------------------------------------------------
'           Real composition
    Dim Composition(1 To 11) As Double
    Composition(1) = Val(form1.Carbon(0))
    Composition(2) = Val(form1.Manganese(1))
    Composition(3) = Val(form1.Silicon(2))
    Composition(4) = Val(form1.Aluminum(3))
    Composition(5) = Val(form1.Phosphorus(4))
    Composition(6) = Val(form1.Niobium(5))
    Composition(7) = Val(form1.Molybdenum(6))
    Composition(8) = Val(form1.Nitrogen(7))
    Composition(9) = Val(form1.Sulfur(8))
    Composition(10) = Val(form1.Boron(9))
    Composition(11) = 100 - (Val(form1.Carbon(0)) + Val(form1.Manganese(1)) + Val(form1.Silicon(2)) + Val(form1.Aluminum(3)) _
      + Val(form1.Phosphorus(4)) + Val(form1.Niobium(5)) + Val(form1.Molybdenum(6)) + Val(form1.Nitrogen(7)) + Val(form1.Sulfur(8)) + Val(form1.Boron(9)))
'--------------------------------------------------------------------------------
'   compositon used to calculate carbon-carbon interaction energy Omega
'   steel composition(wt%):C  Si   Mn    Ni   Mo   Cr  V   Co  Cu  Al   W
    
    Dim C(0 To 11)  As Double
    
    C(0) = Val(form1.Carbon(0))
    C(1) = Val(form1.Silicon(2))
    C(2) = Val(form1.Manganese(1))
    C(3) = 0
    C(4) = Val(form1.Molybdenum(6))
    C(5) = 0
    C(6) = 0
    C(7) = 0
    C(8) = 0
    C(9) = Val(form1.Aluminum(3))
    C(10) = 0
    
    w_i = Composition(1) / 100
    x_i = (w_i / 12) / (w_i / 12 + (1 - w_i) / 55.84)

    Call X_Carbon_BC(T, X_bc, X_cb, Composition(), X_Components())
    
  

    WDIFF = MAP_STEEL_OMEGA(C(), x) 'X carbon concentration is obtained in it
  
    W = WDIFF
    DIFFUS = 0
    
    
    x_BAR(0) = x_i
    thick(0) = thick_ini
    H1(0) = (x_BAR(0) - X_cb) / (x_BAR(0) - X_bc)
    
    Dim X_C As Double
    
    For ii = 1 To time_STEPS - 1
    
            H1(ii - 1) = (x_BAR(ii - 1) - X_cb) / (x_BAR(ii - 1) - X_bc) 'Supersaturation
       
        
        
        ' calculate average diffusivity
            DIFFUS = 0
            For j = 1 To 100
                X_C = x_BAR(ii - 1) + j * (X_cb - x_BAR(ii - 1)) / 100
                DIFFUS = DIFFUS + MAP_STEEL_DIFFUS(X_C, T, WDIFF) * (X_cb - x_BAR(ii - 1)) / 100 'cm^2/s
            Next j
            
            D_BAR(ii - 1) = DIFFUS / (X_cb - x_BAR(ii - 1))
            
    
            X1 = 0.6 'guess value, 0<x1<25
            ' Newton Raphson method
            Do
                f1 = PI_SQRT * X1 * (1 - erf(X1)) * Exp(X1 * X1) - H1(ii - 1) '3*log(x1)+log(1-erf(x1))+log(pi_sqrt)-log(0.8)'H1
                'derivative of f1
                f2 = PI_SQRT * Exp(X1 * X1) * (1 + 2 * X1 * X1) * (1 - erf(X1)) + 2 * X1  '3/x1+1/(1-erf(x1))*2/pi_sqrt*exp(-x1*x1)
                X2 = X1 - f1 / f2
                k = k + 1
                delta_y = Abs(X2 - X1)
                ''cout<<"x1= "<<x1<<endl
                If delta_y < eps Then
                    Exit Do
                End If
                X1 = X2
           Loop
       
        alpha1(ii - 1) = (2 * Sqr(D_BAR(ii - 1))) * X1
        Alpha3(ii - 1) = alpha1(ii - 1) * (PI_SQRT / H1(ii - 1) ^ 0.5)
        
        time(ii) = 0 + (ii + 1) * delta_time ' in second
        
       
        thick(ii) = 0.5 * 10000 * Alpha3(ii - 1) * (1 / Sqr(time(ii))) * delta_time + thick(ii - 1) ' in micron
       ' thick(ii) = 10000 * alpha1(ii) * Sqr(time(ii)) + thick_ini
        
        x_BAR(ii) = thick_ini * (x_i - X_bc) / thick(ii) + X_bc
       
        
        If thick(ii) >= thick_equi Then
             thick(ii) = thick_equi
    '        'cout<<"Steel has has reached equilibrium"<<endl
        End If
      
    Next ii
    
    f_austenite = thick(ii - 1) / thick_end
    
    
    If f_austenite > f_equi Or f_austenite < 0# Then
        GoTo The_End
    End If
 
    
The_End: End Function

Public Function erf(ByVal x As Double) As Double
    Dim z, a, b, h As Double
    Dim N As Long
    N = 10000
    a = 0
    b = x
    h = (b - a) / N
    Sum = Exp(-a ^ 2) * 0.5
    For i = 1 To N
        Sum = Sum + Exp(-(a + i * h) ^ 2)
    Next i
    
    Sum = Sum + Exp(-(b * 0.5) ^ 2)
    
    
    Dim summid As Double
    summid = 0#
    For j = 1 To N
        summid = Sum + Exp(-(a + (j - 0.5) * h) ^ 2)
    Next j
    
    z = (Sum + 2 * summid) * h / 3#
    erf = (2 * z) / PI_SQRT
    
End Function



