Attribute VB_Name = "X_OF_CARBON"

Public Function X_Carbon_IA(ByVal T, ByRef X_ab, ByRef X_ba, ByRef composition() As Double, _
                            ByRef X_Components() As Double, ByRef f_austenite)
                            'IA stage;   a for ferrite,  b for austenite,

    Dim name2 As String * 50
    Dim phase1, phase2 As Long  'phase1 austenite, phase2 ferrite
    Dim count As Long
    Dim phase_name() As String * 50
    Dim FCC_NUM() As Integer
    Dim FCC_A1_COUNT As Integer     'Because in some cases there will be two FCC_A1,
                                    'I need to find the right one for austenite
    FCC_A1_COUNT = 0

'set system composition
    For count = 1 To INIT_NO_OF_COMPONENTS()
        Call SET_INIT_COMPONENT_MASS(count, composition(count))
    Next

'set appropriate pressure /Pa and temperature in Kelvin
    Call SET_PRESSURE(101325#)
    Call SET_TEMPERATURE(T)
   
    Dim CCPT As Long
    CCPT = INIT_COMPONENT_NO("C", Len("C"))

'classify phase
    For count = 1 To INIT_NO_OF_PHASES()
        Call INIT_PHASE_NAME(name2, 50, count)
        If (Trim(name2) = "BCC_A2") Then
            Call SET_INIT_PHASE_CLASS(count, NORMAL)
        ElseIf (Trim(name2) = "FCC_A1") Then
            Call SET_INIT_PHASE_CLASS(count, NORMAL)
'        ElseIf (Trim(name2) = "CEMENTITE") Then
'            Call SET_INIT_PHASE_CLASS(count, ABSENT)
        Else
            Call SET_INIT_PHASE_CLASS(count, ABSENT)
        End If
    Next count
    
'classify component
    For i = 1 To INIT_NO_OF_COMPONENTS()
       ' If i = CCPT Then
            Call SET_INIT_COMPONENT_CLASS(i, NORMAL)
       ' Else
           ' Call SET_INIT_COMPONENT_CLASS(i, PARA)
       ' End If
    Next i
    
'do the calculation
    Call COMPUTE_EQUILIBRIUM
    
    
    Dim NUM As Long  'number of phases present at equilibrium
    NUM = EQUIL_NO_OF_PHASES()
    
    If NUM = 1 Then
        MsgBox ("Temperature is higher than A3")
        GoTo The_End
        
    ElseIf NUM = 2 Then
        phase1 = ACT_PHASE_NO("FCC_A1", Len("FCC_A1"))
        phase2 = ACT_PHASE_NO("BCC_A2", Len("BCC_A2"))

' note that ACTIVE means considered in calculation, not present at equilibrium

        X_ab = COMPONENT_X_OF_PHASE(CCPT, phase2, ACTIVE)
        X_ba = COMPONENT_X_OF_PHASE(CCPT, phase1, ACTIVE)
        
    ElseIf NUM > 2 Then
        ReDim phase_name(NUM)
        ReDim FCC_NUM(NUM)
        For i = 0 To NUM - 1
            Call EQUIL_PHASE_NAME(phase_name(i), 50, i + 1)
            
            If Left(phase_name(i), 6) = "FCC_A1" Then
                FCC_A1_COUNT = FCC_A1_COUNT + 1
                FCC_NUM(i) = i + 1
            End If
            
            FCC_NUM(i) = 0
        Next i
      
    End If
    
    If FCC_A1_COUNT >= 1 Then
        For i = 0 To NUM - 1
            If FCC_NUM(i) = i + 1 Then
               If COMPONENT_X_OF_PHASE(CCPT, i + 1, ACTIVE) > 0.2 Then
               'if carbon mole fraction higher than 0.1 then it's carbide, discard this value
                                                    
               Else
                    X_ba = COMPONENT_X_OF_PHASE(CCPT, i + 1, ACTIVE)
                    
               End If
            End If
        Next i
        phase2 = ACT_PHASE_NO("BCC_A2", Len("BCC_A2"))
        X_ab = COMPONENT_X_OF_PHASE(CCPT, phase2, ACTIVE)
    End If
    

    form1.Text1.Text = X_ab
    form1.Text2.Text = X_ba
   
    
    Dim Mass_Of_Austenite As Double
    Mass_Of_Austenite = MASS_IN_PHASE(phase1, ACTIVE)
    Mass2 = MASS_IN_PHASE(phase2, ACTIVE)
    mass3 = SUM_OF_COMPONENT_MASS()
    f_austenite = (Mass_Of_Austenite / 100) * 100 'total mass 100kg, *100 means convert to %

    For i = 1 To 11
        composition(i) = 100 * COMPONENT_W_OF_PHASE(i, phase1, ACTIVE)  '*100 convert mass fraction to wt%
        X_Components(i) = COMPONENT_X_OF_PHASE(i, phase1, ACTIVE)
    Next i
  
    
    If (NUMBER_OF_ERRORS() <> 0) Then
        'error found during calculation.
        'clear error flag, write out the error
        MsgBox ("Error in calculation")
        Call WRITE_ERROR
        Unload form1
    End If

The_End: End Function

Public Function X_Carbon_BIT(ByVal T, ByRef X_ab, ByRef X_ba, ByRef composition() As Double, _
                            ByRef X_Components() As Double) 'BIT stage
                                                            '  a for ferrite,  b for austenite,

    Dim name2 As String * 50
    Dim phase1, phase2 As Long
    Dim count As Long
    Dim phase_name() As String * 50
    Dim FCC_NUM() As Integer
    Dim FCC_A1_COUNT As Integer     'Because in some cases there will be two FCC_A1,
                                    'I need to find the right one for austenite
    FCC_A1_COUNT = 0

'set system composition
    For count = 1 To INIT_NO_OF_COMPONENTS()
        Call SET_INIT_COMPONENT_MASS(count, composition(count))
    Next

'set appropriate pressure /Pa and temperature in Kelvin
    Call SET_PRESSURE(101325#)
    Call SET_TEMPERATURE(T)
   
   
'classify phases
    For count = 1 To INIT_NO_OF_PHASES()
        Call INIT_PHASE_NAME(name2, 50, count)
        
        If (Trim(name2) = "BCC_A2") Then
            Call SET_INIT_PHASE_CLASS(count, NORMAL)
        ElseIf (Trim(name2) = "FCC_A1") Then
            Call SET_INIT_PHASE_CLASS(count, NORMAL)
        Else
            Call SET_INIT_PHASE_CLASS(count, ABSENT)
        End If
    Next count
    
'classify component
    Dim CCPT As Long
    CCPT = INIT_COMPONENT_NO("C", Len("C"))

    For i = 1 To INIT_NO_OF_COMPONENTS()
        
        Call SET_INIT_COMPONENT_CLASS(i, NORMAL)
        If (i = CCPT) Then
            Call SET_INIT_COMPONENT_CLASS(i, NORMAL)
        Else
            Call SET_INIT_COMPONENT_CLASS(i, PARA)
        End If
    Next i

'do the calculation
    Call COMPUTE_EQUILIBRIUM
    
    
    Dim NUM As Long
    NUM = EQUIL_NO_OF_PHASES()
    
    If NUM = 1 Then
        MsgBox ("Temperature is higher than A3")
        GoTo The_End
        
    ElseIf NUM = 2 Then
        phase1 = ACT_PHASE_NO("FCC_A1", Len("FCC_A1"))
        phase2 = ACT_PHASE_NO("BCC_A2", Len("BCC_A2"))

' note that ACTIVE means considered in calculation, not present at equilibrium

        X_ab = COMPONENT_X_OF_PHASE(CCPT, phase2, ACTIVE)
        X_ba = COMPONENT_X_OF_PHASE(CCPT, phase1, ACTIVE)
        
    ElseIf NUM > 2 Then
        ReDim phase_name(NUM)
        ReDim FCC_NUM(NUM)
        For i = 0 To NUM - 1
            Call EQUIL_PHASE_NAME(phase_name(i), 50, i + 1)
            
            If Left(phase_name(i), 6) = "FCC_A1" Then
                FCC_A1_COUNT = FCC_A1_COUNT + 1
                FCC_NUM(i) = i + 1
            End If
            
            FCC_NUM(i) = 0
        Next i
      
    End If
    
    If FCC_A1_COUNT >= 1 Then
        For i = 0 To NUM - 1
            If FCC_NUM(i) = i + 1 Then
               If COMPONENT_X_OF_PHASE(CCPT, i + 1, ACTIVE) > 0.2 Then
               'if carbon mole fraction higher than 0.1 then it's carbide, discard this value
                                                    
               Else
                    X_ba = COMPONENT_X_OF_PHASE(CCPT, i + 1, ACTIVE)
               End If
            End If
        Next i
    End If
    
    form1.Text3.Text = X_ab
    form1.Text4.Text = X_ba

    If (NUMBER_OF_ERRORS() <> 0) Then
        'error found during calculation.
        'clear error flag, write out the error
        MsgBox ("Error in calculation")
        Call WRITE_ERROR
    End If

The_End: End Function

Public Function X_Carbon_BC(ByVal T, ByRef X_bc, ByRef X_cb, ByRef composition() As Double, _
                            ByRef X_Components() As Double)  ' austenite and cementite in equilibrium
                                                            ' b for austenite, c for cementite
    Dim name2 As String * 50
    Dim phase1, phase2 As Long
    Dim count As Long
    Dim phase_name() As String * 50
    Dim FCC_NUM() As Integer
    Dim FCC_A1_COUNT As Integer     'Because in some cases there will be two FCC_A1,
                                    'I need to find the right one for austenite
    FCC_A1_COUNT = 0

'set system composition
    For count = 1 To INIT_NO_OF_COMPONENTS()
        Call SET_INIT_COMPONENT_MASS(count, composition(count))
    Next

'set appropriate pressure /Pa and temperature in Kelvin
    Call SET_PRESSURE(101325#)
    Call SET_TEMPERATURE(T)

'classify phases
        For count = 1 To INIT_NO_OF_PHASES()
            
            Call INIT_PHASE_NAME(name2, 50, count)
            
            If (Trim(name2) = "CEMENTITE") Then
                Call SET_INIT_PHASE_CLASS(count, NORMAL)
            ElseIf (Trim(name2) = "FCC_A1") Then
                Call SET_INIT_PHASE_CLASS(count, NORMAL)
            Else
                Call SET_INIT_PHASE_CLASS(count, ABSENT)
            End If
            
        Next count
        
'classify component
    Dim CCPT As Long
    CCPT = INIT_COMPONENT_NO("C", Len("C"))
    
    For i = 1 To INIT_NO_OF_COMPONENTS()
        If (i <> CCPT) Then
            Call SET_INIT_COMPONENT_CLASS(i, NORMAL)
        End If
    Next i


'do the calculation
    Call COMPUTE_EQUILIBRIUM
    
    Dim NUM As Long
    NUM = EQUIL_NO_OF_PHASES()
        
    If NUM = 2 Then
        phase1 = ACT_PHASE_NO("FCC_A1", Len("FCC_A1"))
        phase2 = ACT_PHASE_NO("CEMENTITE", Len("CEMENTITE"))

' note that ACTIVE means considered in calculation, not present at equilibrium
        X_bc = COMPONENT_X_OF_PHASE(CCPT, phase1, ACTIVE)
        X_cb = COMPONENT_X_OF_PHASE(CCPT, phase2, ACTIVE)
        
    ElseIf NUM > 2 Then
        ReDim phase_name(NUM)
        ReDim FCC_NUM(NUM)
        For i = 0 To NUM - 1
            Call EQUIL_PHASE_NAME(phase_name(i), 50, i + 1)
            
            If Left(phase_name(i), 6) = "FCC_A1" Then
                FCC_A1_COUNT = FCC_A1_COUNT + 1
                FCC_NUM(i) = i + 1
            End If
            
            FCC_NUM(i) = 0
        Next i
      
    End If
    
    If FCC_A1_COUNT >= 1 Then
        
        For i = 0 To NUM - 1
            If FCC_NUM(i) = i + 1 Then
               If COMPONENT_X_OF_PHASE(CCPT, i + 1, ACTIVE) > 0.1 Then
                    'if carbon mole fraction higher than 0.1 then it's carbide, discard this value
               Else
                    X_bc = COMPONENT_X_OF_PHASE(CCPT, i + 1, ACTIVE)
               End If
            End If
        Next i
        
        phase2 = ACT_PHASE_NO("CEMENTITE", Len("CEMENTITE"))
        X_cb = COMPONENT_X_OF_PHASE(CCPT, phase2, ACTIVE)
         
    End If
    
    If (NUMBER_OF_ERRORS() <> 0) Then
        'error found during calculation.
        'clear error flag, write out the error
        MsgBox ("Error in calculation")
        Call WRITE_ERROR
    End If

End Function
